commit:     f544889e3c3cf92b9822ff3d301283af68f3e980
Author:     Philippe Chaintreuil <gentoo_bugs_peep <AT> parallaxshift <DOT> com>
AuthorDate: Mon Aug 21 02:24:54 2017 +0000
Commit:     Michael Orlitzky <mjo <AT> gentoo <DOT> org>
CommitDate: Wed Aug 23 12:19:16 2017 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=f544889e

mail-filter/spamassassin: fix PERL_USE_UNSAFE_INC=0 test failures

Add "use lib '.'" calls before "use SATest" calls in tests that are
missing them.  This fixes tests that fail when the PERL_USE_UNSAFE_INC=0
env var is set.

Also mark this new package as masked, same as -r14.

Gentoo-Bug: 627678
Package-Manager: Portage-2.3.6, Repoman-2.3.1

Signed-off-by: Michael Orlitzky <mjo <AT> gentoo.org>

 .../files/spamassassin-3.4.1-bug_627678.patch      | 197 +++++++++++++++++
 .../spamassassin/spamassassin-3.4.1-r15.ebuild     | 243 +++++++++++++++++++++
 profiles/package.mask                              |   1 +
 3 files changed, 441 insertions(+)

diff --git a/mail-filter/spamassassin/files/spamassassin-3.4.1-bug_627678.patch 
b/mail-filter/spamassassin/files/spamassassin-3.4.1-bug_627678.patch
new file mode 100644
index 00000000000..73765a939b0
--- /dev/null
+++ b/mail-filter/spamassassin/files/spamassassin-3.4.1-bug_627678.patch
@@ -0,0 +1,197 @@
+https://bugs.gentoo.org/show_bug.cgi?id=627678
+--- Mail-SpamAssassin-3.4.1/t/basic_meta.t     2015-04-28 15:56:59.000000000 
-0400
++++ Mail-SpamAssassin-3.4.1/t/basic_meta.t     2017-08-20 21:29:44.000000000 
-0400
+@@ -14,10 +14,11 @@
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
+ use strict;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("meta");
+ use Test;
+ use Mail::SpamAssassin;
+ 
+ use vars qw( %rules %scores $perl_path);
+--- Mail-SpamAssassin-3.4.1/t/body_mod.t       2015-04-28 15:56:58.000000000 
-0400
++++ Mail-SpamAssassin-3.4.1/t/body_mod.t       2017-08-20 21:30:09.000000000 
-0400
+@@ -14,10 +14,11 @@
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
+ use strict;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("body_mod");
+ use Test; BEGIN { plan tests => 3 };
+ 
+ use Mail::SpamAssassin;
+ 
+--- Mail-SpamAssassin-3.4.1/t/config_errs.t    2015-04-28 15:56:59.000000000 
-0400
++++ Mail-SpamAssassin-3.4.1/t/config_errs.t    2017-08-20 21:30:28.000000000 
-0400
+@@ -39,10 +39,11 @@
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
+ use strict;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("config_errs");
+ use Test;
+ use Mail::SpamAssassin;
+ 
+ # initialize SpamAssassin
+--- Mail-SpamAssassin-3.4.1/t/debug.t  2015-04-28 15:56:58.000000000 -0400
++++ Mail-SpamAssassin-3.4.1/t/debug.t  2017-08-20 21:31:02.000000000 -0400
+@@ -14,10 +14,11 @@
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
+ use strict;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("debug");
+ use Test;
+ use Mail::SpamAssassin;
+ 
+ use constant TEST_ENABLED => conf_bool('run_long_tests');
+--- Mail-SpamAssassin-3.4.1/t/get_headers.t    2015-04-28 15:56:58.000000000 
-0400
++++ Mail-SpamAssassin-3.4.1/t/get_headers.t    2017-08-20 21:31:48.000000000 
-0400
+@@ -15,10 +15,11 @@
+   $prefix = '..';
+ }
+ 
+ use strict;
+ use Test;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("get_headers");
+ use Mail::SpamAssassin;
+ 
+ plan tests => 16;
+ 
+--- Mail-SpamAssassin-3.4.1/t/idn_dots.t       2015-04-28 15:56:58.000000000 
-0400
++++ Mail-SpamAssassin-3.4.1/t/idn_dots.t       2017-08-20 21:32:03.000000000 
-0400
+@@ -16,10 +16,11 @@
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
+ use strict;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("normalize_utf8_dots.t");
+ use Test;
+ use Mail::SpamAssassin;
+ use vars qw(%patterns %anti_patterns);
+ 
+--- Mail-SpamAssassin-3.4.1/t/missing_hb_separator.t   2015-04-28 
15:56:58.000000000 -0400
++++ Mail-SpamAssassin-3.4.1/t/missing_hb_separator.t   2017-08-20 
21:32:17.000000000 -0400
+@@ -15,10 +15,11 @@
+   $prefix = '..';
+ }
+ 
+ use strict;
+ use Test;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("missing_hb_separator");
+ use Mail::SpamAssassin;
+ 
+ plan tests => 13;
+ 
+--- Mail-SpamAssassin-3.4.1/t/priorities.t     2015-04-28 15:56:59.000000000 
-0400
++++ Mail-SpamAssassin-3.4.1/t/priorities.t     2017-08-20 21:34:21.000000000 
-0400
+@@ -15,10 +15,11 @@
+ my $prefix = '.';
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("priorities");
+ use strict;
+ use Test; BEGIN { plan tests => NUM_TESTS };
+ 
+ use Mail::SpamAssassin;
+--- Mail-SpamAssassin-3.4.1/t/regexp_valid.t   2015-04-28 15:56:59.000000000 
-0400
++++ Mail-SpamAssassin-3.4.1/t/regexp_valid.t   2017-08-20 21:34:31.000000000 
-0400
+@@ -14,10 +14,11 @@
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
+ use strict;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("regexp_valid");
+ use Test;
+ 
+ # settings
+ plan tests => 24;
+--- Mail-SpamAssassin-3.4.1/t/relative_scores.t        2015-04-28 
15:56:59.000000000 -0400
++++ Mail-SpamAssassin-3.4.1/t/relative_scores.t        2017-08-20 
21:34:43.000000000 -0400
+@@ -9,10 +9,11 @@
+   if (-e 'test_dir') {            # running from test directory, not ..
+     unshift(@INC, '../blib/lib', '.');
+   }
+ }
+ 
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("relative_scores");
+ use Test;
+ use strict;
+ use vars qw/ $error /;
+ 
+--- Mail-SpamAssassin-3.4.1/t/reuse.t  2015-04-28 15:56:58.000000000 -0400
++++ Mail-SpamAssassin-3.4.1/t/reuse.t  2017-08-20 21:34:52.000000000 -0400
+@@ -14,10 +14,11 @@
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
+ use strict;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("reuse");
+ use Test;
+ 
+ use vars qw(%patterns %anti_patterns $perl_path &patterns_run_cb);
+ 
+--- Mail-SpamAssassin-3.4.1/t/uri_html.t       2015-04-28 15:56:58.000000000 
-0400
++++ Mail-SpamAssassin-3.4.1/t/uri_html.t       2017-08-20 21:35:20.000000000 
-0400
+@@ -16,10 +16,11 @@
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
+ use strict;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("uri_html");
+ use Test;
+ use Mail::SpamAssassin;
+ use vars qw(%patterns %anti_patterns);
+ 
+--- Mail-SpamAssassin-3.4.1/t/uri.t    2015-04-28 15:56:59.000000000 -0400
++++ Mail-SpamAssassin-3.4.1/t/uri.t    2017-08-20 21:35:30.000000000 -0400
+@@ -15,10 +15,11 @@
+   $prefix = '..';
+ }
+ 
+ use strict;
+ use Test;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("uri");
+ 
+ use Mail::SpamAssassin;
+ use Mail::SpamAssassin::HTML;
+ use Mail::SpamAssassin::Util;
+--- Mail-SpamAssassin-3.4.1/t/uri_text.t       2015-04-28 15:56:58.000000000 
-0400
++++ Mail-SpamAssassin-3.4.1/t/uri_text.t       2017-08-20 21:35:07.000000000 
-0400
+@@ -16,10 +16,11 @@
+ if (-e 'test_dir') {            # running from test directory, not ..
+   $prefix = '..';
+ }
+ 
+ use strict;
++use lib '.'; use lib 't';
+ use SATest; sa_t_init("uri_text");
+ use Test;
+ use Mail::SpamAssassin;
+ use vars qw(%patterns %anti_patterns);
+ 

diff --git a/mail-filter/spamassassin/spamassassin-3.4.1-r15.ebuild 
b/mail-filter/spamassassin/spamassassin-3.4.1-r15.ebuild
new file mode 100644
index 00000000000..a926f296f96
--- /dev/null
+++ b/mail-filter/spamassassin/spamassassin-3.4.1-r15.ebuild
@@ -0,0 +1,243 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit perl-functions systemd toolchain-funcs user
+
+MY_P="Mail-SpamAssassin-${PV//_/-}"
+S="${WORKDIR}/${MY_P}"
+DESCRIPTION="An extensible mail filter which can identify and tag spam"
+HOMEPAGE="http://spamassassin.apache.org/";
+SRC_URI="mirror://apache/spamassassin/source/${MY_P}.tar.bz2"
+
+LICENSE="Apache-2.0 GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 
~x86-fbsd ~amd64-linux ~x86-linux ~x86-macos"
+IUSE="berkdb cron ipv6 ldap libressl mysql postgres qmail sqlite ssl test"
+
+# The Makefile.PL script checks for dependencies, but only fails if a
+# required (i.e. not optional) dependency is missing. We therefore
+# require most of the optional modules only at runtime.
+REQDEPEND="dev-lang/perl:=
+       dev-perl/HTML-Parser
+       dev-perl/Net-DNS
+       dev-perl/NetAddr-IP
+       virtual/perl-Archive-Tar
+       virtual/perl-Digest-SHA
+       virtual/perl-IO-Zlib
+       virtual/perl-Time-HiRes
+       ssl? (
+               !libressl? ( dev-libs/openssl:0 )
+               libressl? ( dev-libs/libressl )
+       )"
+
+# SpamAssassin doesn't use libwww-perl except as a fallback for when
+# curl/wget are missing, so we depend on one of those instead. Some
+# mirrors use https, so we need those utilities to support SSL.
+#
+# re2c is needed to compile the rules (sa-compile).
+#
+# We still need the old Digest-SHA1 because razor2 has not been ported
+# to Digest-SHA.
+OPTDEPEND="app-crypt/gnupg
+       dev-perl/Digest-SHA1
+       dev-perl/Encode-Detect
+       dev-perl/Geo-IP
+       dev-perl/HTTP-Date
+       dev-perl/Mail-DKIM
+       dev-perl/Mail-SPF
+       dev-perl/Net-Patricia
+       dev-perl/Net-CIDR-Lite
+       dev-util/re2c
+       || ( net-misc/wget[ssl] net-misc/curl[ssl] )
+       virtual/perl-MIME-Base64
+       virtual/perl-Pod-Parser
+       berkdb? ( virtual/perl-DB_File )
+       ipv6? ( dev-perl/IO-Socket-INET6 )
+       ldap? ( dev-perl/perl-ldap )
+       mysql? (
+               dev-perl/DBI
+               dev-perl/DBD-mysql
+       )
+       postgres? (
+               dev-perl/DBI
+               dev-perl/DBD-Pg
+       )
+       sqlite? (
+               dev-perl/DBI
+               dev-perl/DBD-SQLite
+       )
+       ssl? ( dev-perl/IO-Socket-SSL )"
+
+DEPEND="${REQDEPEND}
+       test? (
+               ${OPTDEPEND}
+               virtual/perl-Test-Harness
+       )"
+RDEPEND="${REQDEPEND} ${OPTDEPEND}"
+
+PATCHES=(
+       "${FILESDIR}/spamassassin-3.4.1-bug_7199.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7223.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7231.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7265.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7231-extra.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_7404.patch"
+       "${FILESDIR}/spamassassin-3.4.1-perl526.patch"
+       "${FILESDIR}/spamassassin-3.4.1-bug_627678.patch"
+)
+
+src_prepare() {
+       default
+
+       # The sa_compile test does some weird stuff like hopping around in
+       # the directory tree and calling "make" to create a dist tarball
+       # from ${S}. It fails, and is more trouble than it's worth...
+       perl_rm_files t/sa_compile.t || die 'failed to remove sa_compile test'
+
+       # The spamc tests (which need the networked spamd daemon) fail for
+       # irrelevant reasons. It's too hard to disable them (unlike the
+       # spamd tests themselves -- see src_test), so use a crude
+       # workaround.
+       perl_rm_files t/spamc_*.t || die 'failed to remove spamc tests'
+}
+
+src_configure() {
+       # This is how and where the perl-module eclass disables the
+       # MakeMaker interactive prompt.
+       export PERL_MM_USE_DEFAULT=1
+
+       # Set SYSCONFDIR explicitly so we can't get bitten by bug 48205 again
+       # (just to be sure, nobody knows how it could happen in the first 
place).
+       #
+       # We also set the path to the perl executable explictly. This will be
+       # used to create the initial shebang line in the scripts (bug 62276).
+       perl Makefile.PL \
+               PREFIX="${EPREFIX}/usr" \
+               INSTALLDIRS=vendor \
+               SYSCONFDIR="${EPREFIX}/etc" \
+               DATADIR="${EPREFIX}/usr/share/spamassassin" \
+               PERL_BIN="${EPREFIX}/usr/bin/perl" \
+               ENABLE_SSL="$(usex ssl)" \
+               DESTDIR="${D}" \
+               || die 'failed to create a Makefile using Makefile.PL'
+
+       # Now configure spamc.
+       emake CC="$(tc-getCC)" LDFLAGS="${LDFLAGS}" spamc/Makefile
+}
+
+src_compile() {
+       emake
+       use qmail && emake spamc/qmail-spamc
+}
+
+src_install () {
+       emake install
+       einstalldocs
+
+       # Create the stub dir used by sa-update and friends
+       keepdir /var/lib/spamassassin
+
+       # Move spamd to sbin where it belongs.
+       dodir /usr/sbin
+       mv "${ED}"/usr/bin/spamd "${ED}"/usr/sbin/spamd  || die "move spamd 
failed"
+
+       if use qmail; then
+               dobin spamc/qmail-spamc
+       fi
+
+       ln -s mail/spamassassin "${ED}"/etc/spamassassin || die
+
+       # Disable plugin by default
+       sed -i -e 's/^loadplugin/\#loadplugin/g' \
+               "${ED}/etc/mail/spamassassin/init.pre" \
+               || die "failed to disable plugins by default"
+
+       # Add the init and config scripts.
+       newinitd "${FILESDIR}/3.4.1-spamd.init-r1" spamd
+       newconfd "${FILESDIR}/3.4.1-spamd.conf" spamd
+
+       systemd_newunit "${FILESDIR}/${PN}.service-r2" "${PN}.service"
+       systemd_install_serviced "${FILESDIR}/${PN}.service.conf-r1" \
+                                                        "${PN}.service"
+
+       use postgres && dodoc sql/*_pg.sql
+       use mysql && dodoc sql/*_mysql.sql
+
+       dodoc NOTICE TRADEMARK CREDITS UPGRADE USAGE sql/README.bayes \
+               sql/README.awl procmailrc.example sample-nonspam.txt \
+               sample-spam.txt spamd/PROTOCOL spamd/README.vpopmail \
+               spamd-apache2/README.apache
+
+       # Rename some files so that they don't clash with others.
+       newdoc spamd/README README.spamd
+       newdoc sql/README README.sql
+       newdoc ldap/README README.ldap
+
+       if use qmail; then
+               dodoc spamc/README.qmail
+       fi
+
+       insinto /etc/mail/spamassassin/
+       insopts -m0400
+       newins "${FILESDIR}"/secrets.cf secrets.cf.example
+
+       # Create the directory where sa-update stores its GPG key (if you
+       # choose to import one). If this directory does not exist, the
+       # import will fail. This is bug 396307. We expect that the import
+       # will be performed as root, and making the directory accessible
+       # only to root prevents a warning on the command-line.
+       diropts -m0700
+       dodir /etc/mail/spamassassin/sa-update-keys
+
+       if use cron; then
+               # Install the cron job if they want it.
+               exeinto /etc/cron.daily
+               newexe "${FILESDIR}/update-spamassassin-rules.cron" \
+                          update-spamassassin-rules
+       fi
+
+       # Remove perllocal.pod to avoid file collisions (bug #603338).
+       perl_delete_localpod || die "failed to remove perllocal.pod"
+
+       # The perl-module eclass calls three other functions to clean
+       # up in src_install. The first fixes references to ${D} in the
+       # packlist, and is useful to us, too. The other two functions,
+       # perl_delete_emptybsdir and perl_remove_temppath, don't seem
+       # to be needed: there are no empty directories, *.bs files, or
+       # ${D} paths remaining in our installed image.
+       perl_fix_packlist || die "failed to fix paths in packlist"
+}
+
+src_test() {
+       # Trick the test suite into skipping the spamd tests. Setting
+       # SPAMD_HOST to a non-localhost value causes SKIP_SPAMD_TESTS to be
+       # set in SATest.pm.
+       export SPAMD_HOST=disabled
+       default
+}
+
+pkg_preinst() {
+       # The spamd daemon runs as this user. Use a real home directory so
+       # that it can hold SA configuration.
+       enewuser spamd -1 -1 /home/spamd
+}
+
+pkg_postinst() {
+       elog
+       elog 'No rules are installed by default. You will need to run sa-update'
+       elog 'at least once, and most likely configure SpamAssassin before it'
+       elog 'will work.'
+
+       if ! use cron; then
+               elog
+               elog 'You should consider a cron job for sa-update. One is 
provided'
+               elog 'for daily updates if you enable the "cron" USE flag.'
+       fi
+       elog
+       elog 'Configuration and update help can be found on the wiki:'
+       elog
+       elog '  https://wiki.gentoo.org/wiki/SpamAssassin'
+       elog
+}

diff --git a/profiles/package.mask b/profiles/package.mask
index 373da90a718..e875e4fd55d 100644
--- a/profiles/package.mask
+++ b/profiles/package.mask
@@ -46,6 +46,7 @@ app-arch/unrar-gpl
 # Masked until somebody who uses systemd tells me
 # I didn't break the service file or configuration.
 =mail-filter/spamassassin-3.4.1-r14
+=mail-filter/spamassassin-3.4.1-r15
 
 # Andreas Sturmlechner <[email protected]> (20 Aug 2017)
 # Masked for removal in 30 days. Use kde-apps/kio-extras[mtp,slp] instead.

Reply via email to